#======================================================================
#                        HA Web Konsole (Hawk)
# --------------------------------------------------------------------
#            A web-based GUI for managing and monitoring the
#          Pacemaker High-Availability cluster resource manager
#
# Copyright (c) 2009-2010 Novell Inc., Tim Serong <tserong@novell.com>
#                        All Rights Reserved.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of version 2 of the GNU General Public License as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it would be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
#
# Further, this software is distributed without any warranty that it is
# free of the rightful claim of any third person regarding infringement
# or the like.  Any license provided herein, whether implied or
# otherwise, applies only to this software file.  Patent licenses, if
# any, provided herein do not apply to combinations of this program with
# other software, or any other product whatsoever.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write the Free Software Foundation,
# Inc., 59 Temple Place - Suite 330, Boston MA 02111-1307, USA.
#
#======================================================================

def do_or_die(task)
  begin
    Rake::Task[task].invoke
  rescue Exception => e
    raise "#{task} failed: #{e}"
  end
end

if Gem::VERSION >= "1.5.0"
  # This little bit of insanity re-instates version_requirements
  # (deprecated), because rails:freeze:gems in rails 2.3.10 still
  # relies on it, but it's gone in rubygems 1.5
  module Gem
    class Dependency
      def version_requirements
        requirement
      end
    end
  end
end

namespace :freeze do
  desc "Freeze Rails (but actually fail if there's an error)"
  task :rails do
    do_or_die 'rails:freeze:gems'
  end

  desc "Freeze Gems (but actually fail if there's an error)"
  task :gems do
    do_or_die 'gems:unpack'
  end
end

